#include "stdafx.h"


#include "Gui.h"


// initializes GUI
void GUI::guiInitialize(HWND hWnd,int size,COLORREF x,COLORREF o)
{
	m_hWnd = hWnd;
	m_sizeLine = 5;

	m_Pen_x = CreatePen(PS_SOLID,m_sizeLine,x);
	m_Pen_o = CreatePen(PS_SOLID,m_sizeLine,o);
	m_size = size;
	
	m_sizeCell = m_size / 3;

	m_ret = false;

	RECT rt1,rt2;
	GetWindowRect(m_hWnd,&rt1);
	GetClientRect(m_hWnd,&rt2);
	
	int CyAreaNotClient = (rt2.top - rt2.bottom) - (rt1.top - rt1.bottom);
	int CxAreaNotClient = (rt1.right - rt1.left) - (rt2.right - rt2.left);

	SetWindowPos(m_hWnd,NULL,0,0,m_size + CxAreaNotClient,m_size + CyAreaNotClient ,SWP_NOMOVE|SWP_NOZORDER);
}
	
// paints GUI
void GUI::guiPaint()
{
	PAINTSTRUCT ps;
	HDC hdc;
	
	hdc = BeginPaint(m_hWnd, &ps);
	// TODO: Add any drawing code here...
	//
	
	// draw the lines:

	// left vertical
	MoveToEx(hdc,0,m_sizeCell,NULL);
	LineTo(hdc,m_size,m_sizeCell);
	
	// right vertical
	MoveToEx(hdc,0,m_sizeCell*2,NULL);
	LineTo(hdc,m_size,m_sizeCell*2);

	// top horizontal
	MoveToEx(hdc,m_sizeCell,0,NULL);
	LineTo(hdc,m_sizeCell,m_size);

	// bottom horizontal
	MoveToEx(hdc,m_sizeCell*2,0,NULL);
	LineTo(hdc,m_sizeCell*2,m_size);


	// Draw the cells
	
	for (int i=0;i<3;i++)
		for (int j=0;j<3;j++)
		{
			int x,y;
			x = i * m_sizeCell;
			y = j * m_sizeCell;

			// fst used to make the drawing nicer
			int fst = m_sizeLine;

			if(arrayCells[i][j]==O)
			{
				SelectObject(hdc,m_Pen_o);
				Ellipse(hdc,x+fst,y+fst,x+m_sizeCell-fst,y+m_sizeCell-fst);
			}
			else if (arrayCells[i][j]==X)
			{
				SelectObject(hdc,m_Pen_x);

				MoveToEx(hdc,x+fst,y+fst,NULL);
				LineTo(hdc,x+m_sizeCell-fst,y+m_sizeCell-fst);
				
				MoveToEx(hdc,x+m_sizeCell-fst,y+fst,NULL);
				LineTo(hdc,x+fst,y + m_sizeCell-fst);
			}

		}

	// End of drawing
	EndPaint(m_hWnd, &ps);
	
}

// set new value to a cell
bool GUI::guiSetCellValue(int i,int j,CELL newValue)
{
	if ( arrayCells[i][j] != newValue )
	{
		 arrayCells[i][j] = newValue;
		 
		 // cause Winodws to repaint the whole window
		 RECT rect;
		 GetClientRect(m_hWnd,&rect);
		 /*
		 int x,y;
		 x = i * m_sizeCell;
		 y = j * m_sizeCell;
		 rect.top = x;
		 rect.left = y;
		 rect.bottom = rect.top + m_sizeCell;
		 rect.right = rect.left + m_sizeCell;
		 */

		 InvalidateRect(m_hWnd,&rect,TRUE); 
	}

	if (arrayCells[0][j] == newValue && arrayCells[1][j] == newValue && arrayCells[2][j] == newValue)
		return true;
	if (arrayCells[i][0] == newValue && arrayCells[i][1] == newValue && arrayCells[i][2] == newValue)
		return true;
	if (arrayCells[0][0] == newValue && arrayCells[1][1] == newValue && arrayCells[2][2] == newValue)
		return true;
	if (arrayCells[2][0] == newValue && arrayCells[1][1] == newValue && arrayCells[0][2] == newValue)
		return true;
	return false;


}

// return the value at a a certain cell
void GUI::guiGetCellValue(int i,int j,CELL* pValue)
{
	*pValue = arrayCells[i][j];
}

// returns which cell was hit ( maps mouse clicks )
void GUI::guiGetWhichCell(int x,int y,int* i,int* j)
{
	*i = x / m_sizeCell;
	*j = y / m_sizeCell;
}
