
#include <windows.h>

typedef enum CELL_tag_
{
	Empty	= 0,
	X		= 1,
	O		= 2
} CELL;

class GUI
{
public:
	GUI()
	{
		for (int i=0;i<3;i++)
			for (int j=0;j<3;j++)
				arrayCells[i][j] = Empty;
			
		m_Pen_x = NULL;
		m_Pen_o = NULL;
	}
	~GUI()
	{	
		if(m_Pen_x)
			DeleteObject(m_Pen_x);
		if(m_Pen_o)
			DeleteObject(m_Pen_o);
	}

	// initializes GUI
	void guiInitialize(HWND hWnd,int size,COLORREF x,COLORREF o);
	
	// paints GUI
	void guiPaint();

	// set new value to a cell
	bool guiSetCellValue(int i,int j,CELL newValue);

	// return the value at a a certain cell
	void guiGetCellValue(int i,int j,CELL* pValue);

	// returns which cell was hit ( maps mouse clicks )
	void guiGetWhichCell(int x,int y,int* i,int* j);
	
	bool GetRet(){return m_ret;}

	void SetRet(bool ret){m_ret = ret;}

private:
	HWND		m_hWnd;
	HPEN		m_Pen_x;
	HPEN		m_Pen_o;
	int			m_size;
	int			m_sizeLine;
	int			m_sizeCell;
	CELL		arrayCells[3][3];
	bool		m_ret;
};
